unit formspectrum_unit;

{$mode objfpc}{$H+}

interface

uses
  Classes, ctypes, SysUtils, uos_flat, Math, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    ProgressBar1: TProgressBar;
    ProgressBar10: TProgressBar;
    ProgressBar2: TProgressBar;
    ProgressBar3: TProgressBar;
    ProgressBar4: TProgressBar;
    ProgressBar5: TProgressBar;
    ProgressBar6: TProgressBar;
    ProgressBar7: TProgressBar;
    ProgressBar8: TProgressBar;
    ProgressBar9: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure closeplayer;
    procedure LoopProcPlayer;
  private

  public

  end;

  equalizer_band_type=record
    lo_freq,hi_freq:integer;
    text:string[10];
  end;


Var

  Equalizer_Bands:array[1..10] of equalizer_band_type;


  Form1: TForm1;

  UOSLoaded:Boolean=false;

  res, x, y,z: integer;
  thearray : array of cfloat;
  ordir, opath, SoundFilename, PA_FileName, SF_FileName, MP_FileName: string;
  PlayerIndex1, InputIndex1, OutputIndex1 : integer;

implementation

{$R *.lfm}

{ TForm1 }
procedure TForm1.ClosePlayer;
begin
  button1.Enabled:=True;
end;

procedure TForm1.LoopProcPlayer;
var i,v:integer;
Begin
  If uos_getstatus(PlayerIndex1) > 0 then
  begin
    i:=1;
    thearray := uos_InputFiltersGetLevelArray(PlayerIndex1,InputIndex1);
    x := 0;
    while x < length(thearray) -1 do
    begin
      if i<=10 then
      begin
        v:=max(Trunc(thearray[x]*100),Trunc(thearray[x+1]*100));
        TProgressBar(findcomponent('ProgressBar'+inttostr(i))).position:=v;
      end;
      x:=x+2;
      inc(i);
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
begin
  button1.Enabled:=False;
  res := uos_LoadLib(Pchar(PA_FileName), Pchar(SF_FileName), pchar(MP_FileName), nil, nil, nil) ;
  If Res<>0 Then
  begin
    label1.caption:='UOS in Error';
    exit;
  end
  else
  begin
    // uos loaded
    //// Create the player.
    //// PlayerIndex : from 0 to what your computer can do !
    //// If PlayerIndex exists already, it will be overwriten...
    PlayerIndex1 := 0;
    if uos_CreatePlayer(PlayerIndex1) then
    begin
      //// add a Input from audio-file with default parameters
      //////////// PlayerIndex : Index of a existing Player
      ////////// FileName : filename of audio file
      //  result : -1 nothing created, otherwise Input Index in array
      InputIndex1 := uos_AddFromFile(PlayerIndex1,(pchar(SoundFilename)),-1, -1, 4096);
      if InputIndex1 > -1 then
      begin
        //// add a Output into device with default parameters
        //////////// PlayerIndex : Index of a existing Player
        //  result : -1 nothing created, otherwise Output Index in array
        OutputIndex1 := uos_AddIntoDevOut(PlayerIndex1, -1, 0.3, -1, -1, -1, 4096, -1) ;
        if OutputIndex1 > -1 then
        begin
          // Spectrum : create  bandpass filters with alsobuf set to false, how many you want:
          for i:=1 to 10 do
          begin
            uos_InputAddFilter(PlayerIndex1, InputIndex1, Equalizer_Bands[i].lo_freq,Equalizer_Bands[i].hi_freq, 1, 3, false, nil);
          end;
          uos_EndProc(PlayerIndex1, @ClosePlayer);
          uos_LoopProcIn(PlayerIndex1, InputIndex1, @LoopProcPlayer);
          /////// everything is ready, here we are, lets play it...
          uos_Play(PlayerIndex1);
          button1.Enabled:=False;
        end;
        button1.Enabled:=True;
      end;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  form1.DoubleBuffered:=true;
  PA_FileName := ordir + 'lib\Windows\32bit\LibPortaudio-32.dll';
  SF_FileName := ordir + 'lib\Windows\32bit\LibSndFile-32.dll';
  MP_FileName := ordir + 'lib\Windows\32bit\LibMpg123-32.dll';
  SoundFilename := ordir + 'sound\rhapsody.mp3';

  Equalizer_Bands[1].lo_freq:=18;
  Equalizer_Bands[1].hi_freq:=46;
  Equalizer_Bands[1].Text:='31.25';
  Equalizer_Bands[2].lo_freq:=47;
  Equalizer_Bands[2].hi_freq:=94;
  Equalizer_Bands[2].Text:='62.5';
  Equalizer_Bands[3].lo_freq:=95;
  Equalizer_Bands[3].hi_freq:=188;
  Equalizer_Bands[3].Text:='125';
  Equalizer_Bands[4].lo_freq:=189;
  Equalizer_Bands[4].hi_freq:=375;
  Equalizer_Bands[4].Text:='250';
  Equalizer_Bands[5].lo_freq:=376;
  Equalizer_Bands[5].hi_freq:=750;
  Equalizer_Bands[5].Text:='500';
  Equalizer_Bands[6].lo_freq:=751;
  Equalizer_Bands[6].hi_freq:=1500;
  Equalizer_Bands[6].Text:='1K';
  Equalizer_Bands[7].lo_freq:=1501;
  Equalizer_Bands[7].hi_freq:=3000;
  Equalizer_Bands[7].Text:='2K';
  Equalizer_Bands[8].lo_freq:=3001;
  Equalizer_Bands[8].hi_freq:=6000;
  Equalizer_Bands[8].Text:='4K';
  Equalizer_Bands[9].lo_freq:=6001;
  Equalizer_Bands[9].hi_freq:=12000;
  Equalizer_Bands[9].Text:='8K';
  Equalizer_Bands[10].lo_freq:=12001;
  Equalizer_Bands[10].hi_freq:=20000;
  Equalizer_Bands[10].Text:='16K';


end;

end.

